| shuffleseq

## Wiki

The master copies of EMBOSS documentation are available at http://emboss.open-bio.org/wiki/Appdocs on the EMBOSS Wiki.

Please help by correcting and extending the Wiki pages.

## Function

Shuffle a set of sequences maintaining composition

## Description

shuffleseq reads one or more sequences and writes them out again in a random (shuffled) order. The number of shuffles may be specified. Only the order of sequences is changed, no bases or residues are changed.

## Usage

Here is a sample session with shuffleseq

This makes two randomised copies of the input sequence:

    % shuffleseq -shuffle 2
    Shuffle a set of sequences maintaining composition
    Input sequence(s): tembl:L48662
    output sequence(s) [l48662.fasta]:

Go to the input files for this example
Go to the output files for this example

## Command line arguments

    Shuffle a set of sequences maintaining composition
    Version: EMBOSS:6.6.0.0

       Standard (Mandatory) qualifiers:
      [-sequence]          seqall     Sequence(s) filename and optional format, or
                                      reference (input USA)
      [-outseq]            seqoutall  [.] Sequence set(s)
                                      filename and optional format (output USA)

       Additional (Optional) qualifiers: (none)
       Advanced (Unprompted) qualifiers:
       -shuffle            integer    [1] Number of shuffles (Any integer value)

       Associated qualifiers:

       "-sequence" associated qualifiers
       -sbegin1            integer    Start of each sequence to be used
       -send1              integer    End of each sequence to be used
       -sreverse1          boolean    Reverse (if DNA)
       -sask1              boolean    Ask for begin/end/reverse
       -snucleotide1       boolean    Sequence is nucleotide
       -sprotein1          boolean    Sequence is protein
       -slower1            boolean    Make lower case
       -supper1            boolean    Make upper case
       -scircular1         boolean    Sequence is circular
       -squick1            boolean    Read id and sequence only
       -sformat1           string     Input sequence format
       -iquery1            string     Input query fields or ID list
       -ioffset1           integer    Input start position offset
       -sdbname1           string     Database name
       -sid1               string     Entryname
       -ufo1               string     UFO features
       -fformat1           string     Features format
       -fopenfile1         string     Features file name

       "-outseq" associated qualifiers
       -osformat2          string     Output seq format
       -osextension2       string     File name extension
       -osname2            string     Base file name
       -osdirectory2       string     Output directory
       -osdbname2          string     Database name to add
       -ossingle2          boolean    Separate file for each entry
       -oufo2              string     UFO features
       -offormat2          string     Features format
       -ofname2            string     Features file name
       -ofdirectory2       string     Output directory

       General qualifiers:
       -auto               boolean    Turn off prompts
       -stdout             boolean    Write first file to standard output
       -filter             boolean    Read first file from standard input, write
                                      first file to standard output
       -options            boolean    Prompt for standard and additional values
       -debug              boolean    Write debug output to program.dbg
       -verbose            boolean    Report some/full command line options
       -help               boolean    Report command line options and exit. More
                                      information on associated and general
                                      qualifiers can be found with -help -verbose
       -warning            boolean    Report warnings
       -error              boolean    Report errors
       -fatal              boolean    Report fatal errors
       -die                boolean    Report dying program messages
       -version            boolean    Report version number and exit

Qualifier | Type | Description | Allowed values | Default
--- | --- | --- | --- | ---
Standard (Mandatory) qualifiers
[-sequence] (Parameter 1) | seqall | Sequence(s) filename and optional format, or reference (input USA) | Readable sequence(s) | Required
[-outseq] (Parameter 2) | seqoutall | Sequence set(s) filename and optional format (output USA) | Writeable sequence(s) | <*>.format
Additional (Optional) qualifiers
(none)
Advanced (Unprompted) qualifiers
-shuffle | integer | Number of shuffles | Any integer value | 1
Associated qualifiers
"-sequence" associated seqall qualifiers
-sbegin1 -sbegin_sequence | integer | Start of each sequence to be used | Any integer value | 0
-send1 -send_sequence | integer | End of each sequence to be used | Any integer value | 0
-sreverse1 -sreverse_sequence | boolean | Reverse (if DNA) | Boolean value Yes/No | N
-sask1 -sask_sequence | boolean | Ask for begin/end/reverse | Boolean value Yes/No | N
-snucleotide1 -snucleotide_sequence | boolean | Sequence is nucleotide | Boolean value Yes/No | N
-sprotein1 -sprotein_sequence | boolean | Sequence is protein | Boolean value Yes/No | N
-slower1 -slower_sequence | boolean | Make lower case | Boolean value Yes/No | N
-supper1 -supper_sequence | boolean | Make upper case | Boolean value Yes/No | N
-scircular1 -scircular_sequence | boolean | Sequence is circular | Boolean value Yes/No | N
-squick1 -squick_sequence | boolean | Read id and sequence only | Boolean value Yes/No | N
-sformat1 -sformat_sequence | string | Input sequence format | Any string |
-iquery1 -iquery_sequence | string | Input query fields or ID list | Any string |
-ioffset1 -ioffset_sequence | integer | Input start position offset | Any integer value | 0
-sdbname1 -sdbname_sequence | string | Database name | Any string |
-sid1 -sid_sequence | string | Entryname | Any string |
-ufo1 -ufo_sequence | string | UFO features | Any string |
-fformat1 -fformat_sequence | string | Features format | Any string |
-fopenfile1 -fopenfile_sequence | string | Features file name | Any string |
"-outseq" associated seqoutall qualifiers
-osformat2 -osformat_outseq | string | Output seq format | Any string |
-osextension2 -osextension_outseq | string | File name extension | Any string |
-osname2 -osname_outseq | string | Base file name | Any string |
-osdirectory2 -osdirectory_outseq | string | Output directory | Any string |
-osdbname2 -osdbname_outseq | string | Database name to add | Any string |
-ossingle2 -ossingle_outseq | boolean | Separate file for each entry | Boolean value Yes/No | N
-oufo2 -oufo_outseq | string | UFO features | Any string |
-offormat2 -offormat_outseq | string | Features format | Any string |
-ofname2 -ofname_outseq | string | Features file name | Any string |
-ofdirectory2 -ofdirectory_outseq | string | Output directory | Any string |
General qualifiers
-auto | boolean | Turn off prompts | Boolean value Yes/No | N
-stdout | boolean | Write first file to standard output | Boolean value Yes/No | N
-filter | boolean | Read first file from standard input, write first file to standard output | Boolean value Yes/No | N
-options | boolean | Prompt for standard and additional values | Boolean value Yes/No | N
-debug | boolean | Write debug output to program.dbg | Boolean value Yes/No | N
-verbose | boolean | Report some/full command line options | Boolean value Yes/No | Y
-help | boolean | Report command line options and exit. More information on associated and general qualifiers can be found with -help -verbose | Boolean value Yes/No | N
-warning | boolean | Report warnings | Boolean value Yes/No | Y
-error | boolean | Report errors | Boolean value Yes/No | Y
-fatal | boolean | Report fatal errors | Boolean value Yes/No | Y
-die | boolean | Report dying program messages | Boolean value Yes/No | Y
-version | boolean | Report version number and exit | Boolean value Yes/No | N

## Input file format

shuffleseq reads one or more nucleotide or protein sequences.

The input is a standard EMBOSS sequence query (also known as a 'USA').

Major sequence database sources defined as standard in EMBOSS installations include srs:embl, srs:uniprot and ensembl

Data can also be read from sequence output in any supported format written by an EMBOSS or third-party application.

The input format can be specified by using the command-line qualifier `-sformat xxx`, where 'xxx' is replaced by the name of the required format. The available format names are: gff (gff3), gff2, embl (em), genbank (gb, refseq), ddbj, refseqp, pir (nbrf), swissprot (swiss, sw), dasgff and debug.

See: http://emboss.sf.net/docs/themes/SequenceFormats.html for further information on sequence formats.

### Input files for usage example

'tembl:L48662' is a sequence entry in the example nucleic acid database 'tembl'

### Database entry: tembl:L48662

    ID   L48662; SV 1; linear; mRNA; STD; MUS; 366 BP.
    XX
    AC   L48662;
    XX
    DT   04-NOV-1995 (Rel. 45, Created)
    DT   04-MAR-2000 (Rel. 63, Last updated, Version 4)
    XX
    DE   Mus musculus (cell line C3H/F2-11) chromosome 12 anti-DNA antibody heavy
    DE   chain mRNA.
    XX
    KW   .
    XX
    OS   Mus musculus (house mouse)
    OC   Eukaryota; Metazoa; Chordata; Craniata; Vertebrata; Euteleostomi; Mammalia;
    OC   Eutheria; Euarchontoglires; Glires; Rodentia; Sciurognathi; Muroidea;
    OC   Muridae; Murinae; Mus; Mus.
    XX
    RN   [1]
    RP   1-366
    RX   DOI; 10.1002/eji.1830260939.
    RX   PUBMED; 8814271.
    RA   Wloch M.K., Alexander A.L., Pippen A.M., Pisetsky D.S., Gilkeson G.S.;
    RT   "Differences in V kappa gene utilization and VH CDR3 sequence among
    RT   anti-DNA from C3H-lpr mice and lupus mice with nephritis";
    RL   Eur. J. Immunol. 26(9):2225-2233(1996).
    XX
    DR   IMGT/LIGM; L48662.
    XX
    FH   Key             Location/Qualifiers
    FH
    FT   source          1..366
    FT                   /organism="Mus musculus"
    FT                   /strain="C3H/HeJ-lpr/lpr"
    FT                   /mol_type="mRNA"
    FT                   /cell_line="C3H/F2-11"
    FT                   /cell_type="hybridoma"
    FT                   /tissue_type="spleen"
    FT                   /db_xref="taxon:10090"
    XX
    SQ   Sequence 366 BP; 100 A; 90 C; 85 G; 89 T; 2 other;
         gagnnccagc tgcagcagtc tggacctgag ctggtaaagc ctggggcttc agtgaagatg        60
         tcctgcaagg cttctggata cacattcact agctatgtta tgcactgggt gaatcagaag       120
         cctgggcagg gccttgagtg gattggatat attaatcctt acaatgatgg tactaactac       180
         aatgagaagt tcaaaggcaa ggccacactg acttcagaca aatcctccag cacagcctac       240
         atggagttca gcagcctgac ctctgaggac tctgcggtct attactgtgc aagaaaaact       300
         tcctactata gtaacctata ttactttgac tactggggcc aaggcaccac tctcacagtc       360
         tcctca                                                                  366
    //

## Output file format

The output is a standard EMBOSS sequence file.

The results can be output in one of several styles by using the command-line qualifier `-osformat xxx`, where 'xxx' is replaced by the name of the required format. The available format names are: embl, genbank, gff, pir, swiss, dasgff, debug, listfile, dbmotif, diffseq, excel, feattable, motif, nametable, regions, seqtable, simple, srs, table, tagseq.

See: http://emboss.sf.net/docs/themes/SequenceFormats.html for further information on sequence formats.

### Output files for usage example

### File: l48662.fasta

    >L48662 L48662.1 Mus musculus (cell line C3H/F2-11) chromosome 12 anti-DNA antibody heavy chain mRNA.
    aggtttttatattacaagcatactaagagactcgcgatgatcgcacaattccaaatgtgc
    tcatgggtgtagcaagaacctcaaataaaagggcaaccatgagggtaaagtctccgcatg
    agcccctgggacgcgagagactttctcccgctagtgggtcgaacctgcagtgtcgataat
    tggagttaaaatcgcagcatttacggccatgaattgtgtcgatanacgattcacgcaatc
    gttaagatcaggttcattgggntcacaaaccgtaggccccccgttgcctgacgcgtaacg
    ttcggatttccgtgacttcatctgactactctgtcacattcttacacgacaagctcaaca
    agccgg
    >L48662 L48662.1 Mus musculus (cell line C3H/F2-11) chromosome 12 anti-DNA antibody heavy chain mRNA.
    gtggatggtatccctaacccatgacttgcgattccattgactaataccgatttcgctatg
    cgaataatactgcacaataagcgctgggggttggtttaaanttgcgatgtattatcaggt
    gcatcatacgcgtgtcttcaatcgcaggagaatacaaactcagtcccaagcctaaggcgc
    gtgagacttcattagggcaacggatactgctaactagttaaactcgcatgtaacaactca
    cctgagcggtcgtacatgggcctctcttcccgaagggttgttcgaaaaaagcattgatac
    aggccaggcaagcaccacgtgtcagcactacgatggccgttntcaaagtagctcatacag
    cctcgc

Each run will produce a different sequence.

Note that these two sequences have the same name.

## Data files

None.

## Notes

shuffleseq is useful for producing sets of sequences with randomised order which can be used for checking the statistics of sequence similarity searches.

## References

None.

## Warnings

None.

## Diagnostic Error Messages

None.

## Exit status

It always exits with status 0.

## Known bugs

None.

## See also

Program name | Description
--- | ---
msbar | Mutate a sequence

## Author(s)

Michael Schmitz formerly at:
Lawrence Berkeley Labs, USA

Please report all bugs to the EMBOSS bug team (emboss-bug © emboss.open-bio.org) not to the original author.

## History

## Target users

This program is intended to be used by everyone and everything, from naive users to embedded scripts.

## Comments

None